    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * PinNeedle.java
    029     * --------------
    030     * (C) Copyright 2002-2006, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: MiddlePinNeedle.java,v 1.4.2.3 2006/08/02 10:40:57 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.Area;
    051    import java.awt.geom.Ellipse2D;
    052    import java.awt.geom.GeneralPath;
    053    import java.awt.geom.Point2D;
    054    import java.awt.geom.Rectangle2D;
    055    import java.io.Serializable;
    056
    057    /**
    058     * A needle that is drawn as a pin shape.
    059     */
    060    public class MiddlePinNeedle extends MeterNeedle
    061                                 implements Cloneable, Serializable {
    062
    063        /** For serialization. */
    064        private static final long serialVersionUID = 6237073996403125310L;
    065
    066        /**
    067         * Draws the needle.
    068         *
    069         * @param g2  the graphics device.
    070         * @param plotArea  the plot area.
    071         * @param rotate  the rotation point.
    072         * @param angle  the angle.
    073         */
    074        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    075                                  Point2D rotate, double angle) {
    076
    077            Area shape;
    078            GeneralPath pointer = new GeneralPath();
    079
    080            int minY = (int) (plotArea.getMinY());
    081            //int maxX = (int) (plotArea.getMaxX());
    082            int maxY = (int) (plotArea.getMaxY());
    083            int midY = ((maxY - minY) / 2) + minY;
    084
    085            int midX = (int) (plotArea.getMinX() + (plotArea.getWidth() / 2));
    086            //int midY = (int) (plotArea.getMinY() + (plotArea.getHeight() / 2));
    087            int lenX = (int) (plotArea.getWidth() / 10);
    088            if (lenX < 2) {
    089                lenX = 2;
    090            }
    091
    092            pointer.moveTo(midX - lenX, midY - lenX);
    093            pointer.lineTo(midX + lenX, midY - lenX);
    094            pointer.lineTo(midX, minY);
    095            pointer.closePath();
    096
    097            lenX = 4 * lenX;
    098            Ellipse2D circle = new Ellipse2D.Double(midX - lenX / 2,
    099                                                    midY - lenX, lenX, lenX);
    100
    101            shape = new Area(circle);
    102            shape.add(new Area(pointer));
    103            if ((rotate != null) && (angle != 0)) {
    104                /// we have rotation
    105                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    106                shape.transform(getTransform());
    107            }
    108
    109            defaultDisplay(g2, shape);
    110
    111        }
    112
    113        /**
    114         * Tests another object for equality with this object.
    115         *
    116         * @param object  the object to test.
    117         *
    118         * @return A boolean.
    119         */
    120        public boolean equals(Object object) {
    121            if (object == null) {
    122                return false;
    123            }
    124            if (object == this) {
    125                return true;
    126            }
    127            if (super.equals(object) && object instanceof MiddlePinNeedle) {
    128                return true;
    129            }
    130            return false;
    131        }
    132
    133        /**
    134         * Returns a clone of this needle.
    135         *
    136         * @return A clone.
    137         *
    138         * @throws CloneNotSupportedException if the <code>MiddlePinNeedle</code>
    139         *     cannot be cloned (in theory, this should not happen).
    140         */
    141        public Object clone() throws CloneNotSupportedException {
    142            return super.clone();
    143        }
    144
    145    }